/****************************************************************************

****************************************************************************/

#include "Syscolor.h"
#include "AggressiveOptimize.h"

const char szAppName[] = "Syscolor"; // Our window class, etc

const char rcsRevision[] = "$Revision: 2.20 $"; // Our Version
const char rcsId[] = "$Id: Syscolor.cpp,v 2.20 2000/06/09 05:57:35 Message Exp $"; // The Full RCS ID.

Syscolor *syscolor; // The module

char *szModuleIniPath;
char *szModuleOldIniPath;
char *szLSPath;

//=========================================================
// Initialization and cleanup
//=========================================================

int initModuleEx(HWND ParentWnd, HINSTANCE dllInst, LPCSTR szPath)
{
  int code;
  Window::init(dllInst);
  szLSPath = new char[strlen(szPath) + 1];
  strcpy(szLSPath, szPath);

  szModuleIniPath = new char[strlen(szPath) + strlen("\\MODULES.INI") + 1];
  strcpy(szModuleIniPath, szPath);
  strcat(szModuleIniPath, "\\MODULES.INI");

  szModuleOldIniPath = new char[strlen(szPath) + strlen("\\OLDINI.INI") + 1];
  strcpy(szModuleOldIniPath, szPath);
  strcat(szModuleOldIniPath, "\\OLDINI.INI");

  syscolor = new Syscolor(ParentWnd, code);

  return code;
}


void quitModule(HINSTANCE dllInst)
{
  delete [] szLSPath;
  delete [] szModuleIniPath;
  delete syscolor;
}


//=========================================================
// Bang commands
//=========================================================
void BangSC3DDkShadow(HWND caller, LPCSTR args) {
  syscolor->setColor(0, args);
}

void BangSC3DFace(HWND caller, LPCSTR args) {
  syscolor->setColor(1, args);
}

void BangSCBtnFace(HWND caller, LPCSTR args) {
  syscolor->setColor(2, args);
}

void BangSC3DHiLight(HWND caller, LPCSTR args) {
  syscolor->setColor(3, args);
}

void BangSC3DHighLight(HWND caller, LPCSTR args) {
  syscolor->setColor(4, args);
}

void BangSCBtnHiLight(HWND caller, LPCSTR args) {
  syscolor->setColor(5, args);
}

void BangSCBtnHighLight(HWND caller, LPCSTR args) {
  syscolor->setColor(6, args);
}

void BangSC3DLight(HWND caller, LPCSTR args) {
  syscolor->setColor(7, args);
}

void BangSC3DShadow(HWND caller, LPCSTR args) {
  syscolor->setColor(8, args);
}

void BangSCBtnShadow(HWND caller, LPCSTR args) {
  syscolor->setColor(9, args);
}

void BangSCActiveBorder(HWND caller, LPCSTR args) {
  syscolor->setColor(10, args);
}

void BangSCActiveCaption(HWND caller, LPCSTR args) {
  syscolor->setColor(11, args);
}

void BangSCAppWorkSpace(HWND caller, LPCSTR args) {
  syscolor->setColor(12, args);
}

void BangSCBackground(HWND caller, LPCSTR args) {
  syscolor->setColor(13, args);
}

void BangSCDesktop(HWND caller, LPCSTR args) {
  syscolor->setColor(14, args);
}

void BangSCBtnText(HWND caller, LPCSTR args) {
  syscolor->setColor(15, args);
}

void BangSCCaptionText(HWND caller, LPCSTR args) {
  syscolor->setColor(16, args);
}

void BangSCGrayText(HWND caller, LPCSTR args) {
  syscolor->setColor(17, args);
}

void BangSCHighLight(HWND caller, LPCSTR args) {
  syscolor->setColor(18, args);
}

void BangSCHighLightText(HWND caller, LPCSTR args) {
  syscolor->setColor(19, args);
}

void BangSCInactiveBorder(HWND caller, LPCSTR args) {
  syscolor->setColor(20, args);
}

void BangSCInactiveCaption(HWND caller, LPCSTR args) {
  syscolor->setColor(21, args);
}

void BangSCInactiveCaptionText(HWND caller, LPCSTR args) {
  syscolor->setColor(22, args);
}

void BangSCInfoBk(HWND caller, LPCSTR args) {
  syscolor->setColor(23, args);
}

void BangSCInfoText(HWND caller, LPCSTR args) {
  syscolor->setColor(24, args);
}

void BangSCMenu(HWND caller, LPCSTR args) {
  syscolor->setColor(25, args);
}

void BangSCMenuText(HWND caller, LPCSTR args) {
  syscolor->setColor(26, args);
}

void BangSCScrollBar(HWND caller, LPCSTR args) {
  syscolor->setColor(27, args);
}

void BangSCWindow(HWND caller, LPCSTR args) {
  syscolor->setColor(28, args);
}

void BangSCWindowFrame(HWND caller, LPCSTR args) {
  syscolor->setColor(29, args);
}

void BangSCWindowText(HWND caller, LPCSTR args) {
  syscolor->setColor(30, args);
}

void BangSCGradientActiveCaption(HWND caller, LPCSTR args) {
  syscolor->setColor(31, args);
}

void BangSCGradientInactiveCaption(HWND caller, LPCSTR args) {
  syscolor->setColor(32, args);
}

void BangSCHotLight(HWND caller, LPCSTR args) {
  syscolor->setColor(33, args);
}

void BangSCReset(HWND caller, LPCSTR args) {
  syscolor->fillaColors();
  syscolor->setColors();
}

void BangSCWriteColors(HWND caller, LPCSTR args) {
  if ((!args) || (args[0] == '\0'))
    syscolor->writeIni("Syscolor");
  else
    syscolor->writeIni(args);
}

void BangSCReadColors(HWND caller, LPCSTR args) {
  if ((!args) || (args[0] == '\0'))
    syscolor->readIni("Syscolor");
  else
    syscolor->readIni(args);
}

//=========================================================
// Module code
//=========================================================
COLORREF Syscolor::toColor(LPCSTR args, COLORREF colDef)
{
    
    COLORREF val = colDef;
    
    char tstr[3];
    char* strtocvt;
    char* endstr;
    
    long bignum;
    
    
    if (strlen(args) < 6) {
        return val;
    }
    
    strtocvt = new char[strlen(args) +1];
    strcpy(strtocvt, args);

    if (!colorRGB)
    {
        strncpy(tstr, strtocvt, 2);
        strncpy(strtocvt, strtocvt+4, 2);
        strncpy(strtocvt+4, tstr, 2);
    }
    bignum = strtol( strtocvt, &endstr, 16 );
    
    val = (COLORREF) bignum;
    
    delete [] strtocvt;

    return val;
}


void Syscolor::fillaColors() {
  for (int i = 0; i < 34; i++)
    aColors[i] = cacheColors[i];
}


void Syscolor::setColors() {
  SetSysColors(34, aiElements, aColors);
}

void Syscolor::setColor(int element, LPCSTR args) {
  aColors[element] = toColor(args, aColors[element]);
  SetSysColors(34, aiElements, aColors);
}

void Syscolor::writeIni(LPCSTR section) {
  char Elements[12];
  char tstr[3];
  char* strtocvt;

  updateColorsWithSystem();

  for (int i = 0; i < 34; i++) {
    if (aColors[i] == 0)
      strcpy(Elements, "000000");
    else
      itoa(aColors[i], Elements, 16);

    strtocvt = new char[strlen(Elements) +1];
    strcpy(strtocvt, Elements);
    strncpy(tstr, strtocvt, 2);
    strncpy(strtocvt, strtocvt+4, 2);
    strncpy(strtocvt+4, tstr, 2);

    WritePrivateProfileString(section, acElements[i], strtocvt, iniPath);

    delete [] strtocvt;
  }
}


void Syscolor::readIni(LPCSTR section) {
  bool tempColorRGB = colorRGB;
  char Elements[12];
  colorRGB = false;
  for (int i = 0; i < 34; i++) {
    GetPrivateProfileString(section, acElements[i], "", Elements, 12, iniPath);
    if (Elements[0] != '\0')
      aColors[i] = toColor(Elements, aColors[i]);
  }
  SetSysColors(34, aiElements, aColors);
  colorRGB = tempColorRGB;
}

//
void Syscolor::writeOldIni(LPCSTR section) {
  char Elements[12];
  char tstr[3];
  char* strtocvt;

  updateColorsWithSystem();

  for (int i = 0; i < 34; i++) {
    if (aColors[i] == 0)
      strcpy(Elements, "000000");
    else
      itoa(aColors[i], Elements, 16);

    strtocvt = new char[strlen(Elements) +1];
    strcpy(strtocvt, Elements);
    strncpy(tstr, strtocvt, 2);
    strncpy(strtocvt, strtocvt+4, 2);
    strncpy(strtocvt+4, tstr, 2);

    WritePrivateProfileString(section, acElements[i], strtocvt, oldiniPath);

    delete [] strtocvt;
  }
}

//
void Syscolor::readOldIni(LPCSTR section) {
  bool tempColorRGB = colorRGB;
  char Elements[12];
  colorRGB = false;
  for (int i = 0; i < 34; i++) {
    GetPrivateProfileString(section, acElements[i], "", Elements, 12, oldiniPath);
    if (Elements[0] != '\0')
      aColors[i] = toColor(Elements, aColors[i]);
  }
  SetSysColors(34, aiElements, aColors);
  colorRGB = tempColorRGB;
}
//-

void Syscolor::updateColorsWithSystem() {
  for (int i = 0; i < 34; i++)
    aColors[i] = GetSysColor(aiElements[i]);
}
//---------------------------------------------------------
// Module constructor
//---------------------------------------------------------
Syscolor::Syscolor(HWND parentWnd, int& code):
Window(szAppName)
{

  if (!createWindow(WS_EX_TOOLWINDOW, szAppName, WS_POPUP | WS_CLIPSIBLINGS | WS_CLIPCHILDREN,
                    0, 0, 0, 0, parentWnd))
  {
    MessageBox(NULL, "Unable to create window.", szAppName, MB_TOPMOST);
    code = 1;
    return;
  }

  code = 0;
}


Syscolor::~Syscolor()
{
  destroyWindow();
}


//=========================================================
// Registered messages
//=========================================================

void Syscolor::windowProc(Message& message)
{
  BEGIN_MESSAGEPROC
    MESSAGE(onCreate,            WM_CREATE)
    MESSAGE(onDestroy,           WM_DESTROY)
    MESSAGE(onEndSession,        WM_ENDSESSION)
    MESSAGE(onEndSession,        WM_QUERYENDSESSION)
    MESSAGE(onGetRevId,          LM_GETREVID)
    MESSAGE(onSysCommand,        WM_SYSCOMMAND)
  END_MESSAGEPROC
}


//=========================================================
// Message handlers
//=========================================================

void Syscolor::onCreate(Message& message)
{
  int msgs[] = {LM_GETREVID, 0};
  char sectionToLoad[MAX_LINE_LENGTH];

  SendMessage(hParent, LM_REGISTERMESSAGE, (WPARAM)hWnd, (LPARAM)msgs);
  SetWindowLong(hWnd, GWL_USERDATA, magicDWord);

  //Get Colors from step.rc, if colors aren't defined, get the current
  // system colors
  for (int i = 0; i < 34; i++) {
    cacheColors[i] = GetRCColor(acElements[i], 1110111);
    if (cacheColors[i] = 1110111)
      cacheColors[i] = GetSysColor(aiElements[i]);
  }

  fillaColors();

  GetRCString("SCIniFile", iniPath, szModuleIniPath, MAX_LINE_LENGTH);
  //
  GetRCString("SCOldIniFile", oldiniPath, szModuleIniPath, MAX_LINE_LENGTH);
  
  //
  writeold = GetRCBool("SCWriteOldColors", TRUE);
  if (writeold)
  {
    writeOldIni("oldcolors");
  }


  GetRCString("SCLoadSection", sectionToLoad, "", MAX_LINE_LENGTH);

  nochange = GetRCBool("SCNoChange", TRUE);

  if (!nochange)
{
  

  if ((sectionToLoad != NULL) || (sectionToLoad[0] != '\0'))
    readIni(sectionToLoad);
  else {
    setColors();
  }

}
  colorRGB = true;
  colorRGB = GetRCBool("ColorRGB", TRUE);
  colorRGB = GetRCBool("LSColorBGR", FALSE);


  AddBangCommand("!SC3DDkShadow",BangSC3DDkShadow);
  AddBangCommand("!SC3DFace",BangSC3DFace);
  AddBangCommand("!SCBtnFace",BangSCBtnFace);
  AddBangCommand("!SC3DHiLight",BangSC3DHiLight);
  AddBangCommand("!SC3DHighLight",BangSC3DHighLight);
  AddBangCommand("!SCBtnHiLight",BangSCBtnHiLight);
  AddBangCommand("!SCBtnHighLight",BangSCBtnHighLight);
  AddBangCommand("!SC3DLight",BangSC3DLight);
  AddBangCommand("!SC3DShadow",BangSC3DShadow);
  AddBangCommand("!SCBtnShadow",BangSCBtnShadow);
  AddBangCommand("!SCActiveBorder",BangSCActiveBorder);
  AddBangCommand("!SCActiveCaption",BangSCActiveCaption);
  AddBangCommand("!SCAppWorkSpace",BangSCAppWorkSpace);
  AddBangCommand("!SCBackground",BangSCBackground);
  AddBangCommand("!SCDesktop",BangSCDesktop);
  AddBangCommand("!SCBtnText",BangSCBtnText);
  AddBangCommand("!SCCaptionText",BangSCCaptionText);
  AddBangCommand("!SCGrayText",BangSCGrayText);
  AddBangCommand("!SCHighLight",BangSCHighLight);
  AddBangCommand("!SCHighLightText",BangSCHighLightText);
  AddBangCommand("!SCInactiveBorder",BangSCInactiveBorder);
  AddBangCommand("!SCInactiveCaption",BangSCInactiveCaption);
  AddBangCommand("!SCInactiveCaptionText",BangSCInactiveCaptionText);
  AddBangCommand("!SCInfoBk",BangSCInfoBk);
  AddBangCommand("!SCInfoText",BangSCInfoText);
  AddBangCommand("!SCMenu",BangSCMenu);
  AddBangCommand("!SCMenuText",BangSCMenuText);
  AddBangCommand("!SCScrollBar",BangSCScrollBar);
  AddBangCommand("!SCWindow",BangSCWindow);
  AddBangCommand("!SCWindowFrame",BangSCWindowFrame);
  AddBangCommand("!SCWindowText",BangSCWindowText);
  AddBangCommand("!SCGradientActiveCaption",BangSCGradientActiveCaption);
  AddBangCommand("!SCGradientInactiveCaption",BangSCGradientInactiveCaption);
  AddBangCommand("!SCHotLight",BangSCHotLight);
  AddBangCommand("!SCReset",BangSCReset);
  AddBangCommand("!SCWriteColors",BangSCWriteColors);
  AddBangCommand("!SCReadColors",BangSCReadColors);

}


void Syscolor::onDestroy(Message& message)
{

//
  restoreold = GetRCBool("SCRestoreOldColors", TRUE);
  if(restoreold)
  {
	  readOldIni("oldcolors");
	  setColors();
  }


	
  int msgs[] = {LM_GETREVID, 0};

  SendMessage(hParent, LM_UNREGISTERMESSAGE, (WPARAM)hWnd, (LPARAM)msgs);



  RemoveBangCommand("!SC3DDkShadow");
  RemoveBangCommand("!SC3DFace");
  RemoveBangCommand("!SCBtnFace");
  RemoveBangCommand("!SC3DHiLight");
  RemoveBangCommand("!SC3DHighLight");
  RemoveBangCommand("!SCBtnHiLight");
  RemoveBangCommand("!SCBtnHighLight");
  RemoveBangCommand("!SC3DLight");
  RemoveBangCommand("!SC3DShadow");
  RemoveBangCommand("!SCBtnShadow");
  RemoveBangCommand("!SCActiveBorder");
  RemoveBangCommand("!SCActiveCaption");
  RemoveBangCommand("!SCAppWorkSpace");
  RemoveBangCommand("!SCBackground");
  RemoveBangCommand("!SCDesktop");
  RemoveBangCommand("!SCBtnText");
  RemoveBangCommand("!SCCaptionText");
  RemoveBangCommand("!SCGrayText");
  RemoveBangCommand("!SCHighLight");
  RemoveBangCommand("!SCHighLightText");
  RemoveBangCommand("!SCInactiveBorder");
  RemoveBangCommand("!SCInactiveCaption");
  RemoveBangCommand("!SCInactiveCaptionText");
  RemoveBangCommand("!SCInfoBk");
  RemoveBangCommand("!SCInfoText");
  RemoveBangCommand("!SCMenu");
  RemoveBangCommand("!SCMenuText");
  RemoveBangCommand("!SCScrollBar");
  RemoveBangCommand("!SCWindow");
  RemoveBangCommand("!SCWindowFrame");
  RemoveBangCommand("!SCWindowText");
  RemoveBangCommand("!SCGradientActiveCaption");
  RemoveBangCommand("!SCGradientInactiveCaption");
  RemoveBangCommand("!SCHotLight");
  RemoveBangCommand("!SCReset");
  RemoveBangCommand("!SCWriteColors");
  RemoveBangCommand("!SCReadColors");
}


void Syscolor::onEndSession(Message& message)
{
  message.lResult = SendMessage(hParent, message.uMsg, message.wParam, message.lParam);
}


void Syscolor::onGetRevId(Message& message)
{
  char* buf = (char*)(message.lParam);

  switch (message.wParam)
  {
    case 0:
      sprintf(buf, "syscolor.dll: %s", &rcsRevision[11]);
      buf[strlen(buf) - 1] = '\0';
      break;
    case 1:
      strcpy(buf, &rcsId[1]);
      buf[strlen(buf) - 1] = '\0';
      break;
    default:
      strcpy(buf, "");
  }
  message.lResult = strlen(buf);
}


void Syscolor::onSysCommand(Message& message)
{
  if (message.wParam == SC_CLOSE)
    PostMessage(hParent, WM_KEYDOWN, LM_SHUTDOWN, 0);
  else
    message.lResult = DefWindowProc(hWnd, message.uMsg, message.wParam, message.lParam);
}

//=========================================================
// Bang command handling
//=========================================================


